Index: src/northbridge/via/vx800/vx800_ide.c
===================================================================
--- src/northbridge/via/vx800/vx800_ide.c	(Revision 4427)
+++ src/northbridge/via/vx800/vx800_ide.c	(Arbeitskopie)
@@ -25,244 +25,78 @@
 #include "chip.h"
 #include <arch/io.h>
 #include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
 
-static const idedevicepcitable[16 * 12] = {
-	/*
-	0x02, 0x00, 0x00, 0x00, 0x00, 0x82, 0x00, 0x00,
-	0x00, 0x00, 0xA8, 0xA8, 0xF0, 0x00, 0x00, 0xB6,
-	0x00, 0x00, 0x01, 0x21, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x01, 0x09, 0xC4, 0x06, 0x11, 0x09, 0xC4,
-	0x00, 0xC2, 0xF9, 0x01, 0x10, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x02, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	*/
-
-	0x02, 0x00, 0x00, 0x00, 0x00, 0x82, 0x00, 0x00,
-	0x00, 0x00, 0x99, 0x20, 0xf0, 0x00, 0x00, 0x20,
-	0x00, 0x00, 0x17, 0xF1, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x01, 0x09, 0xC4, 0x06, 0x11, 0x09, 0xC4,
-	0x00, 0xc2, 0x09, 0x01, 0x10, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x02, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-
-	/* Legacy BIOS XP PCI value */
-	/*
-	0x02, 0x00, 0x00, 0x00, 0x00, 0x82, 0x00, 0x00,
-	0x00, 0x00, 0xa8, 0x20, 0x00, 0x00, 0x00, 0xb6,
-	0x00, 0x00, 0x16, 0xF1, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x01, 0x09, 0xC4, 0x06, 0x11, 0x09, 0xC4,
-	0x00, 0x02, 0x09, 0x00, 0x18, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x02, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	*/
-
-	/* ROM legacy BIOS on cn_8562b */
-	/*
-	0x03, 0x00, 0x00, 0x00, 0x00, 0x82, 0x00, 0x00,
-	0x00, 0x00, 0x99, 0x20, 0x60, 0x00, 0x00, 0x20,
-	0x00, 0x00, 0x1E, 0xF1, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x01, 0x09, 0xC4, 0x06, 0x11, 0x09, 0xC4,
-	0x00, 0x02, 0x09, 0x01, 0x18, 0x0C, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x02, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	*/
-
-	/* From legacy BIOS on c7_8562b */
-	/*
-	0x03, 0x00, 0x00, 0x00, 0x00, 0x82, 0x00, 0x00,
-	0x00, 0x00, 0x5E, 0x20, 0x60, 0x00, 0x00, 0xB6,
-	0x00, 0x00, 0x1E, 0xF1, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x01, 0x09, 0xC4, 0x06, 0x11, 0x09, 0xC4,
-	0x00, 0x02, 0x09, 0x01, 0x18, 0x0C, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x02, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
-	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-	*/
+static const idedevicepcitable [16*12]={
+0x02, 0x00, 0x00, 0x00, 0x00, 0x82, 0x00, 0x00, 0x00, 0x00, 0x99, 0x20, 0xf0, 0x00, 0x00, 0x20, 
+0x00, 0x00, 0x17, 0xF1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x09, 0xC4, 0x06, 0x11, 0x09, 0xC4, 
+0x00, 0xc2, 0x09, 0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
+0x02, 0x01, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 };
-
 static void ide_init(struct device *dev)
 {
-	uint8_t enables, Rx89, RxC0;
-	u8 i, data;
-	struct ATA_REG_INIT_TABLE *pEntry;
+	uint8_t enables,Rx89,RxC0;
+	u8 i,data;
+	struct ATA_REG_INIT_TABLE      *pEntry;
 	printk_info("ide_init\n");
+	
+	pci_modify_config8(dev, 0x45, 0x00, 0x80);
+	pci_modify_config8(dev, 0x0A, 0x01, 0xFF);
+	pci_modify_config8(dev, 0x45, 0x80, 0x00);
+	pci_modify_config8(dev, 0x40, 0x02, 0x00);
+	
+	pci_modify_config8(dev, 0x09, 0x00, 0x05);//COMPATIBLE MODE
+	//pci_modify_config8(dev, 0x09, 0x05, 0x05);//native MODE
 
-#if 1
-	/*these 3 lines help to keep interl back door for DID VID SUBID untouched */
-	u16 data16_1, data16_2;
-	data16_1 = pci_read_config16(dev, 0xba);
-	data16_2 = pci_read_config16(dev, 0xbe);
-
-	for (i = 0; i < (16 * 12); i++) {
-		pci_write_config8(dev, 0x40 + i, idedevicepcitable[i]);
+	pci_modify_config8(dev, 0x04, 0x00, 0x07);
+	
+	#if 1
+	/*these 3 lines help to keep interl back door for DID VID SUBID unchanged*/
+	u16 data16_1,data16_2;
+	data16_1=pci_read_config16(dev,0xba);
+	data16_2=pci_read_config16(dev,0xbe);
+	   
+	for(i=0;i<(16*12);i++){
+		pci_write_config8(dev, 0x40+i, idedevicepcitable[i]);
 	}
 	//pci_write_config8(dev, 0x0d, 0x20);
-	data = pci_read_config8(dev, 0x0d);
-	data &= 0x0f;
-	data |= 0x40;
+	data=pci_read_config8(dev,0x0d);
+	data &=0x0f;
+	data |=0x40;
 	pci_write_config8(dev, 0x0d, data);
 
-	//these 2 lines help to keep interl back door for DID VID SUBID untouched
+	//these 2 lines help to keep interl back door for DID VID SUBID unchanged
 	pci_write_config16(dev, 0xba, data16_1);
 	pci_write_config16(dev, 0xbe, data16_2);
 #endif
 	/* Force interrupts to use compat mode. */
 	pci_write_config8(dev, PCI_INTERRUPT_PIN, 0x0);
 	pci_write_config8(dev, PCI_INTERRUPT_LINE, 0xff);
-#if 0
-
-	struct southbridge_via_vt8237r_config *sb =
-	    (struct southbridge_via_vt8237r_config *)dev->chip_info;
-
-	u8 enables;
-	u32 cablesel;
-
-	pci_write_config16(dev, 0x04, 0x0007);
-
-	enables = pci_read_config8(dev, IDE_CS) & ~0x3;
-	enables |= 0x02;
-	pci_write_config8(dev, IDE_CS, enables);
-	enables = pci_read_config8(dev, IDE_CS);
-	printk_debug("Enables in reg 0x40 read back as 0x%x\n", enables);
-
-	/* Enable only compatibility mode. */
-	enables = pci_read_config8(dev, IDE_CONF_II);
-	enables &= ~0xc0;
-	pci_write_config8(dev, IDE_CONF_II, enables);
-	enables = pci_read_config8(dev, IDE_CONF_II);
-	printk_debug("Enables in reg 0x42 read back as 0x%x\n", enables);
-
-	/* Enable prefetch buffers. */
-	enables = pci_read_config8(dev, IDE_CONF_I);
-	enables |= 0xf0;
-	pci_write_config8(dev, IDE_CONF_I, enables);
-
-	/* Flush FIFOs at half. */
-	enables = pci_read_config8(dev, IDE_CONF_FIFO);
-	enables &= 0xf0;
-	enables |= (1 << 2) | (1 << 0);
-	pci_write_config8(dev, IDE_CONF_FIFO, enables);
-
-	/* PIO read prefetch counter, Bus Master IDE Status Reg. Read Retry. */
-	enables = pci_read_config8(dev, IDE_MISC_I);
-	enables &= 0xe2;
-	enables |= (1 << 4) | (1 << 3);
-	pci_write_config8(dev, IDE_MISC_I, enables);
-
-	/* Use memory read multiple, Memory-Write-and-Invalidate. */
-	enables = pci_read_config8(dev, IDE_MISC_II);
-	enables |= (1 << 2) | (1 << 3);
-	pci_write_config8(dev, IDE_MISC_II, enables);
-
-	/* Force interrupts to use compat mode. */
-	pci_write_config8(dev, PCI_INTERRUPT_PIN, 0x0);
-	pci_write_config8(dev, PCI_INTERRUPT_LINE, 0xff);
-
-	/* Cable guy... */
-	cablesel = pci_read_config32(dev, IDE_UDMA);
-	cablesel &= ~((1 << 28) | (1 << 20) | (1 << 12) | (1 << 4));
-	cablesel |= (sb->ide0_80pin_cable << 28) |
-	    (sb->ide0_80pin_cable << 20) |
-	    (sb->ide1_80pin_cable << 12) | (sb->ide1_80pin_cable << 4);
-	pci_write_config32(dev, IDE_UDMA, cablesel);
-#endif
 }
 
+void ide_enable(device_t dev)
+{	
+	pci_modify_config8(dev, 0xB9, 0x01, 0x01);
+}
 static struct device_operations ide_ops = {
-	.read_resources = pci_dev_read_resources,
-	.set_resources = pci_dev_set_resources,
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
 	.enable_resources = pci_dev_enable_resources,
-	.init = ide_init,
-	.enable = 0,
-	.ops_pci = 0,
+	.init		  = ide_init,
+	.enable		  = ide_enable,
+	.ops_pci	  = 0,
 };
 
 static struct pci_driver via_ide_driver __pci_driver = {
-	.ops = &ide_ops,
+	.ops    = &ide_ops,
 	.vendor = PCI_VENDOR_ID_VIA,
-	.device = PCI_DEVICE_ID_VIA_VX855_IDE,
+	.device = PCI_DEVICE_ID_VIA_VX800_IDE,
 };
Index: src/northbridge/via/vx800/northbridge.c
===================================================================
--- src/northbridge/via/vx800/northbridge.c	(Revision 4427)
+++ src/northbridge/via/vx800/northbridge.c	(Arbeitskopie)
@@ -41,26 +41,26 @@
 u8 acpi_sleep_type = 0;
 
 static void memctrl_init(device_t dev)
-{
+{    
 /*
-  set VGA in uma_ram_setting.c, not in this function.
+   set VGA in uma_ram_setting.c, not in this function.
 */
 #if 0
 	pci_write_config8(dev, 0x85, 0x20);
 	pci_write_config8(dev, 0x86, 0x2d);
-
+	
 	/* Set up VGA timers */
 	pci_write_config8(dev, 0xa2, 0x44);
-
+	
 	/* Enable VGA with a 32mb framebuffer */
 	pci_write_config16(dev, 0xa0, 0xd000);
-
+	
 	pci_write_config16(dev, 0xa4, 0x0010);
-
+	
 	//b0: 60 aa aa 5a 0f 00 00 00 08
 	pci_write_config16(dev, 0xb0, 0xaa00);
 	pci_write_config8(dev, 0xb8, 0x08);
-#endif
+#endif	
 }
 
 static const struct device_operations memctrl_operations = {
@@ -71,22 +71,22 @@
 static const struct pci_driver memctrl_driver __pci_driver = {
 	.ops = &memctrl_operations,
 	.vendor = PCI_VENDOR_ID_VIA,
-	.device = PCI_DEVICE_ID_VIA_VX855_MEMCTRL,
+	.device = PCI_DEVICE_ID_VIA_VX800_MEMCTRL,
 };
 
 static void ram_resource(device_t dev, unsigned long index,
-			 unsigned long basek, unsigned long sizek)
+        unsigned long basek, unsigned long sizek)
 {
-	struct resource *resource;
+        struct resource *resource;
 
-	if (!sizek) {
-		return;
-	}
-	resource = new_resource(dev, index);
-	resource->base = ((resource_t) basek) << 10;
-	resource->size = ((resource_t) sizek) << 10;
-	resource->flags = IORESOURCE_MEM | IORESOURCE_CACHEABLE |
-	    IORESOURCE_FIXED | IORESOURCE_STORED | IORESOURCE_ASSIGNED;
+        if (!sizek) {
+                return;
+        }
+        resource = new_resource(dev, index);
+        resource->base  = ((resource_t)basek) << 10;
+        resource->size  = ((resource_t)sizek) << 10;
+        resource->flags =  IORESOURCE_MEM | IORESOURCE_CACHEABLE | \
+                IORESOURCE_FIXED | IORESOURCE_STORED | IORESOURCE_ASSIGNED;
 }
 
 static void tolm_test(void *gp, struct device *dev, struct resource *new)
@@ -106,8 +106,7 @@
 	struct resource *min;
 	u32 tolm;
 	min = 0;
-	search_bus_resources(bus, IORESOURCE_MEM, IORESOURCE_MEM,
-			     tolm_test, &min);
+	search_bus_resources(bus, IORESOURCE_MEM, IORESOURCE_MEM, tolm_test, &min);
 	tolm = 0xffffffffUL;
 	if (min && tolm > min->base) {
 		tolm = min->base;
@@ -116,21 +115,26 @@
 	return tolm;
 }
 
+#if HAVE_HIGH_TABLES==1
+#define HIGH_TABLES_SIZE 64	// maximum size of high tables in KB
+extern uint64_t high_tables_base, high_tables_size;
+#endif
+
 static void pci_domain_set_resources(device_t dev)
 {
 	/* 
 	 * the order is important to find the correct ram size.
 	 */
-	u8 ramregs[] = { 0x43, 0x42, 0x41, 0x40 };
+	u8 ramregs[] = {0x43, 0x42, 0x41, 0x40};
 	device_t mc_dev;
-	u32 pci_tolm;
+       u32 pci_tolm;
 	u8 reg;
-
+	
 	printk_spew("Entering vx800 pci_domain_set_resources.\n");
 
-	pci_tolm = find_pci_tolm(&dev->link[0]);
-	mc_dev = dev_find_device(PCI_VENDOR_ID_VIA,
-				 PCI_DEVICE_ID_VIA_VX855_MEMCTRL, 0);
+        pci_tolm = find_pci_tolm(&dev->link[0]);
+	mc_dev = dev_find_device(PCI_VENDOR_ID_VIA, 
+				PCI_DEVICE_ID_VIA_VX800_MEMCTRL, 0);
 
 	if (mc_dev) {
 		unsigned long tomk, tolmk;
@@ -141,7 +145,7 @@
 		 * once the register value is not zero, the ramsize is
 		 * this register's value multiply 64 * 1024 * 1024
 		 */
-		for (rambits = 0, i = 0; i < ARRAY_SIZE(ramregs); i++) {
+		for(rambits = 0, i = 0; i < ARRAY_SIZE(ramregs); i++) {
 			unsigned char reg;
 			rambits = pci_read_config8(mc_dev, ramregs[i]);
 			if (rambits != 0)
@@ -150,17 +154,15 @@
 /*
 Get memory size and frame buffer from northbridge's registers.
 if register with invalid value we set frame buffer size to 32M for default, but it won't happen.
-*/
+*/ 
 		reg = pci_read_config8(mc_dev, 0xa1);
 		reg &= 0x70;
 		reg = reg >> 4;
 		/* TOP 1M SM Memory */
-		if (reg == 0x0)
-			tomk = (((rambits << 6) - 32 - VIACONFIG_TOP_SM_SIZE_MB) * 1024);	// Set frame buffer 32M for default
-		else
-			tomk =
-			    (((rambits << 6) - (4 << reg) -
-			      VIACONFIG_TOP_SM_SIZE_MB) * 1024);
+		if(reg == 0x0) 
+			tomk = (((rambits << 6) - 32) * 1024);	// Set frame buffer 32M for default
+		else 
+			tomk = (((rambits << 6) - (4 << reg)) * 1024);
 
 		printk_spew("tomk is 0x%x\n", tomk);
 		/* Compute the Top Of Low Memory, in Kb */
@@ -172,24 +174,30 @@
 		/* Report the memory regions */
 		idx = 10;
 		/* TODO: Hole needed? */
-		ram_resource(dev, idx++, 0, 640);	/* first 640k */
+		ram_resource(dev, idx++, 0, 640); /* first 640k */
 		/* Leave a hole for vga, 0xa0000 - 0xc0000 */
 		ram_resource(dev, idx++, 768, (tolmk - 768));
+
+#if HAVE_HIGH_TABLES==1
+		/* Leave some space for ACPI, PIRQ and MP tables */
+		high_tables_base = (tomk - HIGH_TABLES_SIZE) * 1024;
+		high_tables_size = HIGH_TABLES_SIZE * 1024;
+#endif
 	}
 	assign_resources(&dev->link[0]);
 }
 
 static const struct device_operations pci_domain_ops = {
-	.read_resources = pci_domain_read_resources,
-	.set_resources = pci_domain_set_resources,
-	.enable_resources = enable_childrens_resources,
-	.init = 0,
-	.scan_bus = pci_domain_scan_bus,
-};
+        .read_resources   = pci_domain_read_resources,
+        .set_resources    = pci_domain_set_resources,
+        .enable_resources = enable_childrens_resources,
+        .init             = 0,
+        .scan_bus         = pci_domain_scan_bus,
+};  
 
 static void cpu_bus_init(device_t dev)
 {
-	initialize_cpus(&dev->link[0]);
+        initialize_cpus(&dev->link[0]);
 }
 
 static void cpu_bus_noop(device_t dev)
@@ -197,27 +205,27 @@
 }
 
 static const struct device_operations cpu_bus_ops = {
-	.read_resources = cpu_bus_noop,
-	.set_resources = cpu_bus_noop,
-	.enable_resources = cpu_bus_noop,
-	.init = cpu_bus_init,
-	.scan_bus = 0,
+        .read_resources   = cpu_bus_noop,
+        .set_resources    = cpu_bus_noop,
+        .enable_resources = cpu_bus_noop,
+        .init             = cpu_bus_init,
+        .scan_bus         = 0,
 };
 
 static void enable_dev(struct device *dev)
 {
 	printk_spew("In VX800 enable_dev for device %s.\n", dev_path(dev));
 
-	/* Set the operations if it is a special bus type */
-	if (dev->path.type == DEVICE_PATH_PCI_DOMAIN) {
-		dev->ops = &pci_domain_ops;
+        /* Set the operations if it is a special bus type */
+        if (dev->path.type == DEVICE_PATH_PCI_DOMAIN) {
+                dev->ops = &pci_domain_ops;
 		pci_set_method(dev);
-	} else if (dev->path.type == DEVICE_PATH_APIC_CLUSTER) {
-		dev->ops = &cpu_bus_ops;
-	}
+        }        else if (dev->path.type == DEVICE_PATH_APIC_CLUSTER) {
+                dev->ops = &cpu_bus_ops;
+        }
 }
 
 struct chip_operations northbridge_via_vx800_ops = {
 	CHIP_NAME("VIA VX800 Chipset")
-	    .enable_dev = enable_dev,
+	.enable_dev = enable_dev,
 };
Index: src/northbridge/via/vx800/vx800_nb_host_bus.c
===================================================================
--- src/northbridge/via/vx800/vx800_nb_host_bus.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_nb_host_bus.c	(Revision 0)
@@ -0,0 +1,66 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ops.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "chip.h"
+#include <arch/io.h>
+#include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
+
+void nb_host_bus_init(device_t dev)
+{	
+	// fine-tune
+	// If no settings, C7 will hang or reboot in XP, but CN will not.
+	pci_modify_config8(dev, 0x51, 0x84, 0x00);
+	pci_modify_config8(dev, 0x52, 0x0F, 0x03);
+	pci_modify_config8(dev, 0x54, 0x04, 0x00);
+	pci_modify_config8(dev, 0x55, 0x04, 0x00);  
+	pci_modify_config8(dev, 0x59, 0x09, 0x01);    
+	pci_modify_config8(dev, 0x5C, 0x10, 0x10);      
+	pci_modify_config8(dev, 0x5F, 0x0E, 0x08);        
+	pci_modify_config8(dev, 0x92, 0xFF, 0x04);  // ACPI Base addr
+	pci_modify_config8(dev, 0x97, 0x01, 0x01);  // APIC MSI  
+	pci_modify_config8(dev, 0x99, 0x02, 0x00);  // APIC MSI  
+	//GTL
+	pci_modify_config8(dev, 0x73, 0xFF, 0x66);
+	pci_modify_config8(dev, 0xB2, 0xFF, 0x33);  
+	pci_modify_config8(dev, 0xB3, 0xFF, 0x33);   
+	pci_modify_config8(dev, 0xBC, 0xFF, 0x33); 
+	pci_modify_config8(dev, 0xBD, 0xFF, 0x33);   
+	pci_modify_config8(dev, 0xC5, 0x30, 0x20);     
+	pci_modify_config8(dev, 0xC8, 0x10, 0x00);
+}
+static struct device_operations nb_host_bus_ops = {
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init		  = nb_host_bus_init,
+	.enable		  = 0,
+	.ops_pci	  = 0,
+};
+
+static struct pci_driver via_nb_host_bus_driver __pci_driver = {
+	.ops    = &nb_host_bus_ops,
+	.vendor = PCI_VENDOR_ID_VIA,
+	.device = PCI_DEVICE_ID_VIA_VX800_NB_HOST_BUS,
+};
Index: src/northbridge/via/vx800/vx800_sb_vlink.c
===================================================================
--- src/northbridge/via/vx800/vx800_sb_vlink.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_sb_vlink.c	(Revision 0)
@@ -0,0 +1,114 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ops.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "chip.h"
+#include <arch/io.h>
+#include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
+
+void sb_vlink_init(device_t dev)
+{
+	pci_modify_config8(dev, 0xD1, 0x04, 0x00);// Setting HDAC enable      
+
+	/*PCI1Init begin*/	
+	//PCI1 Programming Sequence
+	//(1)Configure D17F7
+	pci_modify_config8(dev, 0x04, 0x00, 0x03);
+	pci_modify_config8(dev, 0x0C, 0x00, 0x08);
+	pci_modify_config8(dev, 0x4F, 0x40, 0x41);      //RENPPB, RP2CFLSH
+	pci_modify_config8(dev, 0x77, 0x00, 0x48);      //ROP2CFLSH, RFFTMR[1:0]. ROP2CFLSH work with Rx4F[0](RP2CFLSH) assertion
+	//pci_modify_config8(dev, 0x51, 0x00, 0x80);      //RSUB_DEC_P2P, RSUBDECOD(Window xp). If Bit7 is set, PCI lock will occured.
+	//pci_modify_config8(dev, 0x51, 0x00, 0x81);      //RSUB_DEC_P2P, RSUBDECOD(Window Vista)
+
+	//(2)Configure D19F0
+	device_t dev1;
+	dev1 = dev_find_device(PCI_VENDOR_ID_VIA, 
+						PCI_DEVICE_ID_VIA_VX800_SB_P2P, 0);
+	if(dev1)
+	pci_modify_config8(dev1, 0x04, 0x00, 0x07); 
+
+	//(3)Performance Recommended Setting
+
+	//Save Power
+	pci_modify_config8(dev, 0xE2, 0x1F, 0x01); 
+	pci_modify_config8(dev, 0xE3, 0xF1, 0x5E); 
+	pci_modify_config8(dev, 0x74, 0x40, 0x00); 
+	//Enhence Host To PCI cycle performance and PCI-To-Host Cycle performance
+	pci_modify_config8(dev, 0x70, 0x00, 0x82);
+	pci_modify_config8(dev, 0x71, 0x30, 0xC0);
+	pci_modify_config8(dev, 0x72, 0x00, 0xEE);
+
+	//Cycle Control
+	pci_modify_config8(dev, 0x73, 0x00, 0x01);
+	pci_modify_config8(dev, 0x74, 0x00, 0x0C);
+	//Arbitration control
+	pci_modify_config8(dev, 0x75, 0x00, 0x0F);
+	pci_modify_config8(dev, 0x76, 0x00, 0xD0);
+	/*PCI1Init end*/	
+
+	/*CCAInit begin*/	
+	pci_modify_config8(dev, 0xFC, 0x02, 0x48);     //RVWREQ, ROABKDOOR
+	//CCA's Register Programming sequence
+	pci_modify_config8(dev, 0x50, 0x00, 0x08);     //Config Azalia's upstream cycle high priority and other low priority
+	pci_modify_config8(dev, 0x51, 0x40, 0x80);     //Disable bypass asynchronous circuit
+	pci_modify_config8(dev, 0x52, 0x00, 0x11);     // Set SM Internal Device and HDAC Occupy Timer
+	pci_modify_config8(dev, 0x53, 0x00, 0x11);     // Set SM Internal Device and HDAC Promote Timer
+	pci_modify_config8(dev, 0x54, 0xFF, 0x02);     //Use SB internal devices's original REQ
+	pci_modify_config8(dev, 0x73, 0x10, 0x00);     //RPINOWSC. Enable APIC Cycle Block P2C Write Cycle
+	pci_modify_config8(dev, 0x74, 0x00, 0x3C);     //RLCKXP2C, RFSBVK.
+	pci_modify_config8(dev, 0xE1, 0x07, 0x00);     //RBLKAPIC, RAZC3
+	pci_modify_config8(dev, 0x7C, 0x04, 0x02);     //RNMIFSB, RFSBVK
+	pci_modify_config8(dev, 0xE0, 0xF0, 0x93);     //RCCA_NEWCLK, RCCA_CLKON. Use New dynamic clock scheme
+	
+	pci_modify_config8(dev, 0xE7, 0xFF, 0x00);     //Let CCA use dynamic clock.
+	//The CCA is also relate to D17F0
+	dev1 = dev_find_device(PCI_VENDOR_ID_VIA, 
+						PCI_DEVICE_ID_VIA_VX800_LPC, 0);
+	if(dev1)
+	//pci_modify_config8(dev1,0x49, 0x1F, 0x00);       //Disable CCA Test Mode
+	pci_modify_config8(dev1, 0x74, 0xFF, 0x00); // Let DMA cycles from internal devices directly go to NB 
+	/*CCAInit finish*/
+}
+
+void sb_vlink_enable(device_t dev)
+{	
+	pci_modify_config8(dev, 0xE6, 0xFF, 0x39); // Enable SMM A-Seg, MSI and Io APIC
+
+	/*open hdac*/
+	pci_modify_config32(dev,0xd1,0x04,0);
+}
+static struct device_operations sb_vlink_ops = {
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init		  = sb_vlink_init,
+	.enable		  = sb_vlink_enable,
+	.ops_pci	  = 0,
+};
+
+static struct pci_driver via_sb_vlink_driver __pci_driver = {
+	.ops    = &sb_vlink_ops,
+	.vendor = PCI_VENDOR_ID_VIA,
+	.device = PCI_DEVICE_ID_VIA_VX800_SB_VLINK,
+};
Index: src/northbridge/via/vx800/vx800_ehci.c
===================================================================
--- src/northbridge/via/vx800/vx800_ehci.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_ehci.c	(Revision 0)
@@ -0,0 +1,72 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+ 
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ops.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "chip.h"
+#include <arch/io.h>
+#include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
+
+void ehci_init(device_t dev)
+{		
+	pci_modify_config8(dev, 0x41, 0xFF, 0x20);
+	pci_modify_config8(dev, 0x42, 0xFF, 0x43);
+	pci_modify_config8(dev, 0x43, 0x00, 0xC0);
+	pci_modify_config8(dev, 0x48, 0x20, 0x9E);
+	pci_modify_config8(dev, 0x49, 0x10, 0x68);
+	pci_modify_config8(dev, 0x4B, 0xFF, 0x09);
+	pci_modify_config8(dev, 0x4C, 0xFF, 0x13);
+	pci_modify_config8(dev, 0x4D, 0x00, 0x94);
+	pci_modify_config8(dev, 0x4E, 0xFF, 0x03);
+	pci_modify_config8(dev, 0x4F, 0xFF, 0x10);
+	pci_modify_config8(dev, 0x50, 0x00, 0x80);
+	pci_modify_config8(dev, 0x52, 0xFF, 0x11);
+	pci_modify_config8(dev, 0x53, 0xFF, 0xbf);
+	pci_modify_config8(dev, 0x55, 0xFF, 0xff);
+	pci_modify_config8(dev, 0x56, 0xFF, 0x0f);
+	pci_modify_config8(dev, 0x5A, 0xFF, 0xCC);
+	pci_modify_config8(dev, 0x5B, 0xFF, 0xCC);
+	pci_modify_config8(dev, 0x5C, 0xFF, 0x00);
+	pci_modify_config8(dev, 0x5D, 0xFF, 0xCC);
+	pci_modify_config8(dev, 0x5E, 0x00, 0x00);
+	pci_modify_config8(dev, 0x64, 0xFF, 0x05);
+	//pci_modify_config8(dev, 0x6B, 0xFF, 0x01);
+	pci_modify_config8(dev, 0x6D, 0x00, 0x00);
+	pci_modify_config8(dev, 0x6F, 0xFF, 0x80);	
+}
+
+static struct device_operations ehci_ops = {
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init		  = ehci_init,
+	.enable		  = 0,
+	.ops_pci	  = 0,
+};
+
+static struct pci_driver via_ehci_driver __pci_driver = {
+	.ops    = &ehci_ops,
+	.vendor = PCI_VENDOR_ID_VIA,
+	.device = PCI_DEVICE_ID_VIA_VX800_EHCI,
+};
Index: src/northbridge/via/vx800/Config.lb
===================================================================
--- src/northbridge/via/vx800/Config.lb	(Revision 4427)
+++ src/northbridge/via/vx800/Config.lb	(Arbeitskopie)
@@ -16,10 +16,21 @@
 ## along with this program; if not, write to the Free Software
 ## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 ##
+uses HAVE_HIGH_TABLES
 
+default HAVE_HIGH_TABLES=1
+
 config chip.h
-object vgabios.o
+object vx800_pci_io_modify_ops.o
 driver northbridge.o
 driver vga.o
 driver vx800_lpc.o
 driver vx800_ide.o
+driver vx800_nb_pmu.o
+driver vx800_nb_traf_ctrl.o
+driver vx800_nb_host_bus.o
+driver vx800_sb_vlink.o
+driver vx800_ehci.o
+driver vx800_nb_host_ctrl.o
+driver vx800_nb_pmu.o
+driver vx800_uhci.o
